package s_com.udojava.evalex;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.List;
import s_com.udojava.evalex.Expression;

class null extends Expression.Function {
  null(String name, int numParams) {
    super(Expression.this, name, numParams);
  }
  
  public BigDecimal eval(List<BigDecimal> parameters) {
    BigInteger ixPrev;
    BigDecimal x = parameters.get(0);
    if (x.compareTo(BigDecimal.ZERO) == 0)
      return new BigDecimal(0); 
    if (x.signum() < 0)
      throw new Expression.ExpressionException(Expression.this, "Argument to SQRT() function must not be negative"); 
    BigInteger n = x.movePointRight(Expression.this.mc.getPrecision() << 1).toBigInteger();
    int bits = n.bitLength() + 1 >> 1;
    BigInteger ix = n.shiftRight(bits);
    do {
      ixPrev = ix;
      ix = ix.add(n.divide(ix)).shiftRight(1);
      Thread.yield();
    } while (ix.compareTo(ixPrev) != 0);
    return new BigDecimal(ix, Expression.this.mc.getPrecision());
  }
}
